/******************************************************************************
  @file    VendorIPerf.h
  @brief   Implementation of vendor internal interface

  DESCRIPTION

  ---------------------------------------------------------------------------
******************************************************************************/
// Copyright (c) 2023 Qualcomm Innovation Center, Inc. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause-Clear

#ifndef __PERF_VENDORINTERFACE_H__
#define __PERF_VENDORINTERFACE_H__

#include <sys/types.h>
#include "properties.h"
#include <string>
// Delete Later
#define NODE_MAX 150
#define TRACE_BUF_SZ 512
#define PROP_NAME           "vendor.debug.trace.perf"
//

/* uncomment later
static uint8_t PERF_SYSTRACE;
static uint8_t perf_debug_output = 0;
*/

using namespace std;

#ifdef __cplusplus
extern "C" {
#endif
    enum {
        VENDOR_HINT_START = 0x00001000,
        //activity trigger hints
        VENDOR_ACT_TRIGGER_HINT_BEGIN = 0x00001001,
        VENDOR_HINT_ACTIVITY_START = 0x00001001,
        VENDOR_HINT_ACTIVITY_STOP = 0x00001002,
        VENDOR_HINT_ACTIVITY_RESUME = 0x00001003,
        VENDOR_HINT_ACTIVITY_PAUSE = 0x00001004,
        VENDOR_HINT_PROCESS_START = 0x00001005,
        VENDOR_HINT_NET_OPS = 0x00001006,
        VENDOR_HINT_FD_COUNT = 0x00001007,
        VENDOR_ACT_TRIGGER_HINT_END = 0x0000103F,

        //perf events
        VENDOR_PERF_EVENT_BEGIN = 0x00001040,
        VENDOR_HINT_DISPLAY_OFF = 0x00001040,
        VENDOR_HINT_DISPLAY_ON = 0x00001041,
        VENDOR_HINT_FIRST_DRAW = 0x00001042,
        VENDOR_HINT_TAP_EVENT = 0x00001043,
        VENDOR_HINT_APP_WORKLOAD_TYPE = 0x00001044,
        VENDOR_HINT_WORKLOAD_HEAVY = 0x00001045,
        VENDOR_HINT_HEADROOM_REGULATOR = 0x00001046,
        VENDOR_HINT_SENSOR_DATA = 0x00001047,
        VENDOR_HINT_THERMAL_UPDATE = 0x00001048,
        VENDOR_HINT_TOGGLE_GAMEOPT = 0x00001049,
        VENDOR_HINT_PICARD_TOP_APP = 0x0000104A,
        VENDOR_HINT_PICARD_RENDER_RATE = 0x0000104B,
        VENDOR_HINT_PICARD_LOW_LAT = 0x0000104C,
        VENDOR_HINT_PICARD_HIGH_CPUUTIL = 0x0000104D,
        VENDOR_HINT_PICARD_LOAD_CHANGED = 0x0000104E,
        VENDOR_HINT_PICARD_THREAD_PIPELINE = 0x0000104F,
        VENDOR_HINT_DRAG_START = 0x00001051,
        VENDOR_HINT_DRAG_END = 0x00001052,
        VENDOR_HINT_DISPLAY_DOZE = 0x00001053,
        VENDOR_HINT_PICARD_HINT_SCENARIO = 0x00001054,
        VENDOR_HINT_GAME_ACTION_DISABLE = 0x00001055,
        VENDOR_HINT_CONTENT_FPS = 0x00001056,
        VENDOR_PERF_EVENT_END = 0x0000107F,

        //perf hints
        VENDOR_PERF_HINT_BEGIN = 0x00001080,
        VENDOR_HINT_SCROLL_BOOST = 0x00001080,
        VENDOR_HINT_FIRST_LAUNCH_BOOST = 0x00001081,
        VENDOR_HINT_SUBSEQ_LAUNCH_BOOST = 0x00001082,
        VENDOR_HINT_ANIM_BOOST = 0x00001083,
        VENDOR_HINT_ACTIVITY_BOOST = 0x00001084,
        VENDOR_HINT_TOUCH_BOOST = 0x00001085,
        VENDOR_HINT_MTP_BOOST = 0x00001086,
        VENDOR_HINT_DRAG_BOOST = 0x00001087,
        VENDOR_HINT_PACKAGE_INSTALL_BOOST = 0x00001088,
        VENDOR_HINT_ROTATION_LATENCY_BOOST = 0x00001089,
        VENDOR_HINT_ROTATION_ANIM_BOOST = 0x00001090,
        VENDOR_HINT_PERFORMANCE_MODE = 0x00001091,
        VENDOR_HINT_APP_UPDATE = 0x00001092,
        VENDOR_HINT_KILL = 0x00001093,
        VENDOR_HINT_FPS_UPDATE = 0x00001094,
        VENDOR_HINT_SPLIT_WINDOW = 0x00001095,
        VENDOR_HINT_BOOST_RENDERTHREAD = 0x00001096,
        VENDOR_HINT_LARGER_COMP_CYCLE = 0x00001097,
        VENDOR_HINT_PICARD_GPU_DISPLAY_MODE = 0x00001098,
        VENDOR_HINT_PICARD_GPU_ONLY_MODE = 0x00001099,
        VENDOR_HINT_PICARD_DISPLAY_ONLY_MODE = 0x0000109A,
        VENDOR_HINT_FPS_IMMEDIATE_UPDATE = 0x0000109B,
        VENDOR_HINT_PASS_PID = 0x0000109C,
        VENDOR_HINT_TEST = 0x0000109D,
        VENDOR_HINT_PERF_INIT_CHECK = 0x0000109E,
        VENDOR_HINT_IME_LAUNCH_EVENT = 0x0000109F,
        VENDOR_HINT_BINDAPP          = 0x000010A0,
        VENDOR_HINT_WARM_LAUNCH      = 0x000010A1,
        VENDOR_HINT_PKG_SPEED        = 0x000010A2,
        VENDOR_HINT_PKG_INSTALL      = 0x000010A3,
        VENDOR_HINT_PKG_UNINSTALL    = 0x000010A4,
        VENDOR_HINT_EXPENSIVE_RENDERING = 0x000010A5,
        VENDOR_HINT_PREFLING_BOOST = 0x000010A6,
        VENDOR_HINT_HEIF_DECODE_ENCODE_BOOST = 0x000010A7,
        VENDOR_HINT_HDR_CONTENT = 0x000010A8,

        VENDOR_PERF_HINT_END = 0x000011FF,

        //reserved for power hints
        VENDOR_POWER_HINT_BEGIN = 0x00001200,
        VENDOR_POWER_HINT_END = 0x000015FF,

        VENDOR_FEEDBACK_INPUT_HINT_BEGIN = 0x00001600,
        VENDOR_FEEDBACK_WORKLOAD_TYPE = 0x00001601,
        VENDOR_FEEDBACK_LAUNCH_END_POINT = 0x00001602,
        VENDOR_FEEDBACK_GPU_HEADROOM = 0x00001603,
        VENDOR_FEEDBACK_PA_FW = 0x00001604,
        VENDOR_FEEDBACK_PA_SPEED = 0x00001605,
        VENDOR_FEEDBACK_PA_PREKILL = 0x00001606,
        VENDOR_FEEDBACK_PA_ULMK = 0x00001607,
        VENDOR_FEEDBACK_MAX_PIPELINE_NUM = 0x00001608,
        VENDOR_FEEDBACK_INPUT_HINT_END = 0x00001632,
        VENDOR_HINT_END = 0x00002000,
    };

    enum {
        MPCTLV3_TOGGLE_POWER_COLLAPSE                      = 0x40400000,
        MPCTLV3_L2_POWER_COLLAPSE_PERF                     = 0x40404000,
        MPCTLV3_LPM_BIAS_HYST                              = 0x40408000,
        MPCTLV3_LPM_LEVELS_REF_STDDEV                      = 0x4040C000,
        MPCTLV3_LPM_LEVELS_TMR_ADD                         = 0x40410000,
        MPCTLV3_LPM_IPI_PREDICTION                         = 0x40414000,

        MPCTLV3_MIN_FREQ_CLUSTER_BIG_CORE_0                 = 0x40800000,
        MPCTLV3_MIN_FREQ_CLUSTER_BIG_CORE_1                 = 0x40800010,
        MPCTLV3_MIN_FREQ_CLUSTER_BIG_CORE_2                 = 0x40800020,
        MPCTLV3_MIN_FREQ_CLUSTER_BIG_CORE_3                 = 0x40800030,
        MPCTLV3_MIN_FREQ_CLUSTER_LITTLE_CORE_0                 = 0x40800100,
        MPCTLV3_MIN_FREQ_CLUSTER_LITTLE_CORE_1                 = 0x40800110,
        MPCTLV3_MIN_FREQ_CLUSTER_LITTLE_CORE_2                 = 0x40800120,
        MPCTLV3_MIN_FREQ_CLUSTER_LITTLE_CORE_3                 = 0x40800130,
        MPCTLV3_MIN_FREQ_CLUSTER_PRIME_CORE_0                 = 0x40800200,
        MPCTLV3_MIN_FREQ_CLUSTER_TITANIUM_CORE_0              = 0x40800300,
        MPCTLV3_MIN_FREQ_CLUSTER_TITANIUM_CORE_1              = 0x40800310,

        MPCTLV3_MAX_FREQ_CLUSTER_BIG_CORE_0                 = 0x40804000,
        MPCTLV3_MAX_FREQ_CLUSTER_BIG_CORE_1                 = 0x40804010,
        MPCTLV3_MAX_FREQ_CLUSTER_BIG_CORE_2                 = 0x40804020,
        MPCTLV3_MAX_FREQ_CLUSTER_BIG_CORE_3                 = 0x40804030,
        MPCTLV3_MAX_FREQ_CLUSTER_LITTLE_CORE_0                 = 0x40804100,
        MPCTLV3_MAX_FREQ_CLUSTER_LITTLE_CORE_1                 = 0x40804110,
        MPCTLV3_MAX_FREQ_CLUSTER_LITTLE_CORE_2                 = 0x40804120,
        MPCTLV3_MAX_FREQ_CLUSTER_LITTLE_CORE_3                 = 0x40804130,
        MPCTLV3_MAX_FREQ_CLUSTER_PRIME_CORE_0                 = 0x40804200,
        MPCTLV3_MAX_FREQ_CLUSTER_TITANIUM_CORE_0              = 0x40804300,
        MPCTLV3_MAX_FREQ_CLUSTER_TITANIUM_CORE_1              = 0x40804310,

        MPCTLV3_WALT_ADAPTIVE_LOW_FREQ_BIG                = 0x40808000,
        MPCTLV3_WALT_ADAPTIVE_LOW_FREQ_LITTLE             = 0x40808100,
        MPCTLV3_WALT_ADAPTIVE_LOW_FREQ_PRIME              = 0x40808200,
        MPCTLV3_WALT_ADAPTIVE_LOW_FREQ_TITANIUM           = 0x40808300,

        MPCTLV3_WALT_ADAPTIVE_HIGH_FREQ_BIG               = 0x4080C000,
        MPCTLV3_WALT_ADAPTIVE_HIGH_FREQ_LITTLE            = 0x4080C100,
        MPCTLV3_WALT_ADAPTIVE_HIGH_FREQ_PRIME             = 0x4080C200,
        MPCTLV3_WALT_ADAPTIVE_HIGH_FREQ_TITANIUM          = 0x4080C300,

        MPCTLV3_SCHED_BOOST                               = 0x40C00000,
        MPCTLV3_SCHED_PREFER_IDLE                         = 0x40C04000,
        MPCTLV3_SCHED_MIGRATE_COST                        = 0x40C08000,
        MPCTLV3_SCHED_SMALL_TASK                          = 0x40C0C000,
        MPCTLV3_SCHED_MOSTLY_IDLE_LOAD                    = 0x40C10000,
        MPCTLV3_SCHED_MOSTLY_IDLE_NR_RUN                  = 0x40C14000,
        MPCTLV3_SCHED_INIT_TASK_LOAD                      = 0x40C18000,
        MPCTLV3_SCHED_UPMIGRATE                           = 0x40C1C000,
        MPCTLV3_SCHED_DOWNMIGRATE                         = 0x40C20000,
        MPCTLV3_SCHED_MOSTLY_IDLE_FREQ                    = 0x40C24000,
        MPCTLV3_SCHED_GROUP                               = 0x40C28000,
        MPCTLV3_SCHED_SPILL_NR_RUN                        = 0x40C2C000,
        MPCTLV3_SCHED_STATIC_CPU_PWR_COST                 = 0x40C30000,
        MPCTLV3_SCHED_RESTRICT_CLUSTER_SPILL              = 0x40C34000,
        MPCTLV3_SCHED_FREQ_AGGR_GROUP                     = 0x40C38000,
        MPCTLV3_SCHED_CPUSET_TOP_APP                      = 0x40C3C000,
        MPCTLV3_SCHED_CPUSET_FOREGROUND                   = 0x40C40000,
        MPCTLV3_SCHED_CPUSET_SYSTEM_BACKGROUND            = 0x40C44000,
        MPCTLV3_SCHED_CPUSET_BACKGROUND                   = 0x40C48000,
        MPCTLV3_SCHED_SET_FREQ_AGGR                       = 0x40C4C000,
        MPCTLV3_SCHED_ENABLE_THREAD_GROUPING              = 0x40C50000,
        MPCTLV3_SCHED_GROUP_UPMIGRATE                     = 0x40C54000,
        MPCTLV3_SCHED_GROUP_DOWNMIGRATE                   = 0x40C58000,
        MPCTLV3_SCHED_FREQ_AGGR_THRESHOLD                 = 0x40C5C000,
        MPCTLV3_SCHEDTUNE_PREFER_IDLE                     = 0x40C60000,
        MPCTLV3_SCHED_INITIAL_TASK_UTIL                   = 0x40C64000,
        MPCTLV3_SCHED_LOAD_BOOST                          = 0x40C68000,
        MPCTLV3_SCHED_LITTLE_CLUSTER_COLOC_FMIN_KHZ       = 0x40C6C000,
        MPCTLV3_SCHEDTUNE_BOOST                           = 0x40C70000,
        MPCTLV3_SCHED_BUSY_HYSTERSIS_CPU_MASK             = 0x40C74000,
        MPCTLV3_SCHED_MIN_TASK_UTIL_FOR_COLOCATION        = 0x40C78000,
        MPCTLV3_SCHED_MIN_TASK_UTIL_FOR_BOOST             = 0x40C7C000,
        MPCTLV3_SCHED_TASK_BOOST                          = 0x40C80000,
        MPCTLV3_SCHED_USER_HINT                           = 0x40C84000,
        MPCTLV3_SCHED_TASK_UNFILTER_NR_WINDOWS            = 0x40C88000,
        MPCTLV3_SCHED_COLOC_DOWNMIGRATE_NS                = 0x40C8C000,
        MPCTLV3_SCHED_BUSY_HYSTERESIS_ENABLE_COLOC_CPUS   = 0x40C90000,
        MPCTLV3_SCHED_COLOC_BIAS_HYST                     = 0x40C94000,
        MPCTLV3_SCHED_WINDOW_STATS_POLICY                 = 0x40C98000,
        MPCTLV3_SCHED_MANY_WAKEUP_THRESHOLD               = 0x40C9C000,
        MPCTLV3_SCHED_SYNC_HINT_ENABLE                    = 0x40CA0000,
        MPCTLV3_SCHED_WINDOW_TICKS_UPDATE                 = 0x40CA4000,
        MPCTLV3_SCHED_PREFER_SPREAD                       = 0x40CA8000,
        MPCTLV3_SCHED_UCLAMP_BOOST                        = 0x40CAC000,
        MPCTLV3_SCHED_ENABLE_TASK_BOOST_RENDERTHREAD      = 0x40CB0000,
        MPCTLV3_SCHED_DISABLE_TASK_BOOST_RENDERTHREAD     = 0x40CB4000,
        MPCTLV3_SCHED_TASK_UNFILTER_PERIOD                = 0x40CB8000,
        MPCTLV3_SCHED_CONSERVATIVE_PL                     = 0x40CBC000,
        MPCTLV3_SCHED_COLOC_BUZY_HYST_CPU_PCT             = 0x40CC0000,
        MPCTLV3_SCHED_COLOC_BUZY_HYST_CPU_NS              = 0x40CC4000,
        MPCTLV3_WALT_RTG_CFS_BOOST_PRIO                   = 0x40CC8000,
        MPCTLV3_SCHED_FORCE_LB_ENABLE                     = 0x40CCC000,
        MPCTLV3_SCHED_LOW_LATENCY                         = 0x40CD0000,
        MPCTLV3_SCHED_MIN_GRANULARITY_NS                  = 0x40CD4000,
        MPCTLV3_WALT_LOW_LATENCY_TASK_THRESHOLD           = 0x40CD8000,
        MPCTLV3_SCHED_TUNE_PREFER_IDLE_FOREGROUND         = 0x40CDC000,
        MPCTLV3_SCHED_UP_DOWN_MIGRATE                     = 0x40CE0000,
        MPCTLV3_STUNE_TOPAPP_SCHEDTUNE_COLOCATE           = 0x40CE4000,
        MPCTLV3_CPUCTL_TOPAPP_UCLAMP_LATENCY_SENSITIVE    = 0x40CE8000,
        MPCTLV3_CPUCTL_FG_UCLAMP_LATENCY_SENSITIVE        = 0x40CEC000,
        MPCTLV3_SCHED_WAKE_UP_IDLE                        = 0x40CF0000,
        MPCTLV3_SCHED_GROUP_UP_DOWN_MIGRATE               = 0x40CF4000,
        MPCTLV3_SCHED_UTIL_BUSY_HYST_CPU_NS_BIG           = 0x40CF8000,
        MPCTLV3_SCHED_UTIL_BUSY_HYST_CPU_NS_LITTLE        = 0x40CF8100,
        MPCTLV3_SCHED_UTIL_BUSY_HYST_CPU_NS_PRIME         = 0x40CF8200,
        MPCTLV3_SCHED_MIN_TASK_UTIL_FOR_UCLAMP            = 0x40CFC000,

        MPCTLV3_MIN_ONLINE_CPU_CLUSTER_BIG                  = 0x41000000,
        MPCTLV3_MIN_ONLINE_CPU_CLUSTER_LITTLE               = 0x41000100,
        MPCTLV3_MIN_ONLINE_CPU_CLUSTER_PRIME                = 0x41000200,
        MPCTLV3_MAX_ONLINE_CPU_CLUSTER_BIG                  = 0x41004000,
        MPCTLV3_MAX_ONLINE_CPU_CLUSTER_LITTLE               = 0x41004100,
        MPCTLV3_CORE_CTL_ENABLE_BIG                         = 0x41008000,
        MPCTLV3_CORE_CTL_CPU_NOT_PREFERRED_BIG              = 0x4100C000,
        MPCTLV3_CORE_CTL_OFFLINE_DELAY_MS_BIG               = 0x41014000,
        MPCTLV3_CORE_CTL_MIN_PARTIAL_CPUS_BIG               = 0x41010000,

        MPCTLV3_ABOVE_HISPEED_DELAY_INTERACTIVE_CLUSTER_BIG = 0x41400000,
        MPCTLV3_BOOST_INTERACTIVE_CLUSTER_BIG               = 0x41404000,
        MPCTLV3_BOOSTPULSE_INTERACTIVE_CLUSTER_BIG          = 0x41408000,
        MPCTLV3_BOOSTPULSE_DURATION_INTERACTIVE_CLUSTER_BIG = 0x4140C000,
        MPCTLV3_GO_HISPEED_LOAD_INTERACTIVE_CLUSTER_BIG     = 0x41410000,
        MPCTLV3_HISPEED_FREQ_INTERACTIVE_CLUSTER_BIG        = 0x41414000,
        MPCTLV3_IO_IS_BUSY_INTERACTIVE_CLUSTER_BIG          = 0x41418000,
        MPCTLV3_MIN_SAMPLE_TIME_INTERACTIVE_CLUSTER_BIG     = 0x4141C000,
        MPCTLV3_TARGET_LOADS_INTERACTIVE_CLUSTER_BIG        = 0x41420000,
        MPCTLV3_TIMER_RATE_INTERACTIVE_CLUSTER_BIG          = 0x41424000,
        MPCTLV3_TIMER_SLACK_INTERACTIVE_CLUSTER_BIG         = 0x41428000,
        MPCTLV3_MAX_FREQ_HYSTERESIS_INTERACTIVE_CLUSTER_BIG = 0x4142C000,
        MPCTLV3_USE_SCHED_LOAD_INTERACTIVE_CLUSTER_BIG      = 0x41430000,
        MPCTLV3_USE_MIGRATION_NOTIF_CLUSTER_BIG             = 0x41434000,
        MPCTLV3_IGNORE_HISPEED_NOTIF_CLUSTER_BIG            = 0x41438000,
        MPCTLV3_SCHEDUTIL_HISPEED_FREQ_CLUSTER_BIG          = 0x4143C000,
        MPCTLV3_SCHEDUTIL_HISPEED_LOAD_CLUSTER_BIG          = 0x41440000,
        MPCTLV3_SCHEDUTIL_PREDICTIVE_LOAD_CLUSTER_BIG       = 0x41444000,
        MPCTLV3_SCHEDUTIL_DOWN_RATE_LIMIT_CLUSTER_BIG       = 0x41448000,
        MPCTLV3_SCHEDUTIL_RTG_BOOST_FREQ_CLUSTER_BIG        = 0x4144C000,

        MPCTLV3_ABOVE_HISPEED_DELAY_INTERACTIVE_CLUSTER_LITTLE = 0x41400100,
        MPCTLV3_BOOST_INTERACTIVE_CLUSTER_LITTLE               = 0x41404100,
        MPCTLV3_BOOSTPULSE_INTERACTIVE_CLUSTER_LITTLE          = 0x41408100,
        MPCTLV3_BOOSTPULSE_DURATION_INTERACTIVE_CLUSTER_LITTLE = 0x4140C100,
        MPCTLV3_GO_HISPEED_LOAD_INTERACTIVE_CLUSTER_LITTLE     = 0x41410100,
        MPCTLV3_HISPEED_FREQ_INTERACTIVE_CLUSTER_LITTLE        = 0x41414100,
        MPCTLV3_IO_IS_BUSY_INTERACTIVE_CLUSTER_LITTLE          = 0x41418100,
        MPCTLV3_MIN_SAMPLE_TIME_INTERACTIVE_CLUSTER_LITTLE     = 0x4141C100,
        MPCTLV3_TARGET_LOADS_INTERACTIVE_CLUSTER_LITTLE        = 0x41420100,
        MPCTLV3_TIMER_RATE_INTERACTIVE_CLUSTER_LITTLE          = 0x41424100,
        MPCTLV3_TIMER_SLACK_INTERACTIVE_CLUSTER_LITTLE         = 0x41428100,
        MPCTLV3_MAX_FREQ_HYSTERESIS_INTERACTIVE_CLUSTER_LITTLE = 0x4142C100,
        MPCTLV3_USE_SCHED_LOAD_INTERACTIVE_CLUSTER_LITTLE      = 0x41430100,
        MPCTLV3_USE_MIGRATION_NOTIF_CLUSTER_LITTLE             = 0x41434100,
        MPCTLV3_IGNORE_HISPEED_NOTIF_CLUSTER_LITTLE            = 0x41438100,
        MPCTLV3_SCHEDUTIL_HISPEED_FREQ_CLUSTER_LITTLE          = 0x4143C100,
        MPCTLV3_SCHEDUTIL_HISPEED_LOAD_CLUSTER_LITTLE          = 0x41440100,
        MPCTLV3_SCHEDUTIL_PREDICTIVE_LOAD_CLUSTER_LITTLE       = 0x41444100,
        MPCTLV3_SCHEDUTIL_DOWN_RATE_LIMIT_CLUSTER_LITTLE       = 0x41448100,
        MPCTLV3_SCHEDUTIL_RTG_BOOST_FREQ_CLUSTER_LITTLE        = 0x4144C100,

        MPCTLV3_TARGET_LOAD_THRESH_CLUSTER_BIG            = 0x41450000,
        MPCTLV3_TARGET_LOAD_THRESH_CLUSTER_LITTLE         = 0x41450100,
        MPCTLV3_TARGET_LOAD_THRESH_CLUSTER_PRIME          = 0x41450200,
        MPCTLV3_TARGET_LOAD_SHIFT_CLUSTER_BIG             = 0x41454000,
        MPCTLV3_TARGET_LOAD_SHIFT_CLUSTER_LITTLE          = 0x41454100,
        MPCTLV3_TARGET_LOAD_SHIFT_CLUSTER_PRIME           = 0x41454200,
        MPCTLV3_UP_RATE_LIMIT_US_BIG                      = 0x41458000,
        MPCTLV3_UP_RATE_LIMIT_US_LITTLE                   = 0x41458100,
        MPCTLV3_UP_RATE_LIMIT_US_PRIME                    = 0x41458200,

        MPCTLV3_CPUBW_HWMON_MIN_FREQ                      = 0x41800000,
        MPCTLV3_CPUBW_HWMON_DECAY_RATE                    = 0x41804000,
        MPCTLV3_CPUBW_HWMON_IO_PERCENT                    = 0x41808000,
        MPCTLV3_CPUBW_HWMON_HYST_OPT                      = 0x4180C000,
        MPCTLV3_CPUBW_HWMON_LOW_POWER_CEIL_MBPS           = 0x41810000,
        MPCTLV3_CPUBW_HWMON_LOW_POWER_IO_PERCENT          = 0x41814000,
        MPCTLV3_CPUBW_HWMON_MAX_FREQ                      = 0x41818000,
        MPCTLV3_CPUBW_HWMON_POLLING_INTERVAL              = 0x4181C000,
        MPCTLV3_CPUBW_HWMON_SAMPLE_MS                     = 0x41820000,
        MPCTLV3_CPUBW_HWMON_IDLE_MBPS                     = 0x41824000,
        MPCTLV3_CPU_LLCC_BW_MIN_FREQ                      = 0x41828000,
        MPCTLV3_CPU_LLCC_BW_UP_SCALE                      = 0x4182C000,
        MPCTLV3_CPU_LLCC_BW_USE_AB                        = 0x41830000,
        MPCTLV3_CPU_LLCC_BW_IO_PERCENT                    = 0x41834000,
        MPCTLV3_CPU_LLCC_BW_HYST_OPT                      = 0x41838000,
        MPCTLV3_CPU_LLCC_BW_SAMPLE_MS                     = 0x4183C000,
        MPCTLV3_CPU_LLCC_BW_POLLING_INTERVAL              = 0x41840000,
        MPCTLV3_CPU_LLCC_BW_MIN_FREQ_V2                   = 0x41844000,
        MPCTLV3_CPU_LLCC_BW_MAX_FREQ_V2                   = 0x41848000,

        MPCTLV3_VIDEO_ENCODE_PB_HINT                      = 0x41C00000,
        MPCTLV3_VIDEO_DECODE_PB_HINT                      = 0x41C04000,
        MPCTLV3_VIDEO_DISPLAY_PB_HINT                     = 0x41C08000,
        MPCTLV3_DISPLAY_EARLY_WAKEUP_HINT                 = 0x41C0C000,

        MPCTLV3_KSM_RUN_STATUS                            = 0x42000000,
        MPCTLV3_KSM_PARAMS                                = 0x42004000,

        MPCTLV3_SAMPLING_RATE_ONDEMAND                    = 0x42400000,
        MPCTLV3_IO_IS_BUSY_ONDEMAND                       = 0x42404000,
        MPCTLV3_SAMPLING_DOWN_FACTOR_ONDEMAND             = 0x42408000,
        MPCTLV3_SYNC_FREQ_ONDEMAND                        = 0x4240C000,
        MPCTLV3_OPTIMAL_FREQ_ONDEMAND                     = 0x42410000,
        MPCTLV3_ENABLE_STEP_UP_ONDEMAND                   = 0x42414000,
        MPCTLV3_MAX_INTERMEDIATE_STEPS_ONDEMAND           = 0x42418000,
        MPCTLV3_NOTIFY_ON_MIGRATE                         = 0x4241C000,

        MPCTLV3_GPU_POWER_LEVEL                           = 0X42800000,
        MPCTLV3_GPU_MIN_POWER_LEVEL                       = 0X42804000,
        MPCTLV3_GPU_MAX_POWER_LEVEL                       = 0X42808000,
        MPCTLV3_GPU_MIN_FREQ                              = 0X4280C000,
        MPCTLV3_GPU_MAX_FREQ                              = 0X42810000,
        MPCTLV3_GPU_BUS_MIN_FREQ                          = 0X42814000,
        MPCTLV3_GPU_BUS_MAX_FREQ                          = 0X42818000,
        MPCTLV3_GPU_DISABLE_GPU_NAP                       = 0X4281C000,
        MPCTLV3_GPU_IS_APP_FG                             = 0X42820000,
        MPCTLV3_GPU_IS_APP_BG                             = 0X42824000,
        MPCTLV3_GPU_LOAD_MOD_PERCENT                      = 0X42828000,
        MPCTLV3_GPU_IDLE_TIMER                            = 0X4282C000,
        MPCTLV3_GPU_MIN_FREQ_MHZ                          = 0X42830000,

        MPCTLV3_UNSUPPORTED                               = 0X42C00000,
        MPCTLV3_IRQ_BALANCER                              = 0X42C04000,
        MPCTLV3_INPUT_BOOST_RESET                         = 0x42C08000,
        MPCTLV3_SWAP_RATIO                                = 0x42C0C000,
        MPCTLV3_STORAGE_CLK_SCALING_DISABLE               = 0x42C10000,
        MPCTLV3_KEEP_ALIVE                                = 0x42C14000,
        MPCTLV3_DISABLE_PPR                               = 0x42C18000,
        MPCTLV3_DISABLE_PASR                              = 0x42C1C000,
        MPCTLV3_PID_AFFINE                                = 0x42C20000,
        MPCTLV3_FPS_HYST_OPCODE                           = 0x42C24000,
        MPCTLV3_ALWAYS_ALLOW_OPCODE                       = 0x42C28000,
        MPCTLV3_SET_SCHEDULER                             = 0x42C2C000,
        MPCTLV3_SCHED_THREAD_PIPELINE                     = 0x42C30000,
        MPCTLV3_DISPLAY_DOZE_OPCODE                       = 0x42C34000,
        MPCTLV3_DISPLAY_HEAVY_RT_AFFINE                   = 0x42C38000,
        MPCTLV3_CONTENT_FPS_OPCODE                        = 0X42C3C000,
        MPCTLV3_GOLD_DYNPREFETCHER_OPCODE                 = 0x42C40000,

        MPCTLV3_LLCBW_HWMON_MIN_FREQ                      = 0x43000000,
        MPCTLV3_LLCBW_HWMON_IO_PERCENT                    = 0x43004000,
        MPCTLV3_LLCBW_HWMON_HYST_OPT                      = 0x43008000,
        MPCTLV3_LLCBW_HWMON_SAMPLE_MS                     = 0x4300C000,
        MPCTLV3_LLCC_DDR_BW_MIN_FREQ                      = 0x43010000,
        MPCTLV3_LLCC_DDR_BW_UP_SCALE                      = 0x43014000,
        MPCTLV3_LLCC_DDR_BW_MAX_FREQ                      = 0x43018000,
        MPCTLV3_LLCC_DDR_BW_DECAY_RATE                    = 0x4301C000,
        MPCTLV3_LLCC_DDR_BW_IO_PERCENT                    = 0x43020000,
        MPCTLV3_LLCC_DDR_BW_HYST_OPT                      = 0x43024000,
        MPCTLV3_LLCC_DDR_BW_LOW_POWER_CEIL_MBPS           = 0x43028000,
        MPCTLV3_LLCC_DDR_BW_LOW_POWER_IO_PERCENT          = 0x4302C000,
        MPCTLV3_LLCC_DDR_BW_POLLING_INTERVAL              = 0x43030000,
        MPCTLV3_LLCC_DDR_BW_SAMPLE_MS                     = 0x43034000,
        MPCTLV3_LLCC_DDR_BW_IDLE_MBPS                     = 0x43038000,
        MPCTLV3_LLCC_DDR_BW_MIN_FREQ_V2                   = 0x4303C000,
        MPCTLV3_LLCC_DDR_BW_MAX_FREQ_V2                   = 0x43040000,
        MPCTLV3_LLCC_DDR_BW_USE_AB                        = 0x43044000,
        MPCTLV3_LLCC_DDR_BW_AB_SCALE                      = 0x43048000,

        MPCTLV3_L3_MEMLAT_MIN_FREQ                        = 0x43400000,
        MPCTLV3_L2_MEMLAT_RATIO_CEIL_0                    = 0x43404000,
        MPCTLV3_L2_MEMLAT_RATIO_CEIL_1                    = 0x43408000,
        MPCTLV3_L3_MEMLAT_STALL_FLOOR_0                   = 0X4340C000,
        MPCTLV3_L3_MEMLAT_STALL_FLOOR_1                   = 0X43410000,
        MPCTLV3_MEMLAT_MIN_FREQ_0                         = 0x43414000,
        MPCTLV3_MEMLAT_MIN_FREQ_1                         = 0x43418000,
        MPCTLV3_LLCC_MEMLAT_MIN_FREQ                      = 0x4341C000,
        MPCTLV3_LLCC_MEMLAT_RATIO_CELL_0                  = 0x43420000,
        MPCTLV3_LLCC_MEMLAT_RATIO_CELL_1                  = 0x43424000,
        MPCTLV3_LLCC_MEMLAT_STALL_FLOOR_0                 = 0x43428000,
        MPCTLV3_LLCC_MEMLAT_STALL_FLOOR_1                 = 0x4342C000,
        MPCTLV3_LLCC_DDR_LAT_MIN_FREQ_0                   = 0x43430000,
        MPCTLV3_LLCC_DDR_LAT_RATIO_CELL_0                 = 0x43434000,
        MPCTLV3_LLCC_DDR_LAT_RATIO_CELL_1                 = 0x43438000,
        MPCTLV3_LLCC_DDR_LAT_STALL_FLOOR_0                = 0x4343C000,
        MPCTLV3_LLCC_DDR_LAT_STALL_FLOOR_1                = 0x43440000,
        MPCTLV3_L3_MEMLAT_MAX_FREQ                        = 0x43444000,
        MPCTLV3_CPU_CPU_DDR_LATFLOOR_MINFREQ              = 0x43448000,
        MPCTLV3_CPU_CPU_DDR_LATFLOOR_MAXFREQ              = 0x4344C000,
        MPCTLV3_LLCC_MEMLAT_MAX_FREQ                      = 0x43450000,
        MPCTLV3_LLCC_DDR_LAT_MAX_FREQ                     = 0x43454000,
        /**
        * We deviated from our single opcode for different cluster nodes here.
        * This has to be fixed in the future release.
        */
        MPCTLV3_BUS_DCVS_L3_MEMLAT_MIN_FREQ_PRIME         = 0x43458000,
        MPCTLV3_BUS_DCVS_LLCC_MEMLAT_MIN_FREQ_SILVER      = 0x4345C000,
        MPCTLV3_BUS_DCVS_LLCC_DDR_LAT_MINFREQ_SILVER      = 0x43460000,
        MPCTLV3_BUS_DCVS_LLCC_DDR_LAT_FREQ_SCALE_PCT      = 0x43464000,
        MPCTLV3_BUS_DCVS_MEMLAT_SAMPLE_MS                 = 0x43468000,
        MPCTLV3_BUS_DCVS_DDR_GOLD_COMPUTE_MAX_FREQ        = 0x4346C000,
        MPCTLV3_BUS_DCVS_LLCC_GOLD_COMPUTE_MAX_FREQ       = 0x43470000,
        MPCTLV3_BUS_DCVS_DDR_PRIME_LATFLOOR_IPM_CEIL      = 0x43474000,
        MPCTLV3_BUS_DCVS_DDR_MEMLAT_ADAPTIVE_HIGH_FREQ    = 0x43478000,
        MPCTLV3_BUS_DCVS_DDR_MEMLAT_ADAPTIVE_LOW_FREQ     = 0x4347C000,
        MPCTLV3_BUS_DCVS_L3_MEMLAT_MIN_FREQ_GOLD          = 0x43480000,
        MPCTLV3_BUS_DCVS_LLCC_DDR_LAT_MINFREQ_PRIME       = 0x43484000,
        MPCTLV3_BUS_DCVS_DDR_LAT_MINFREQ_GOLD             = 0x43488000,
        MPCTLV3_BUS_DCVS_LLCC_MEMLAT_MIN_FREQ_GOLD        = 0x4348C000,
        MPCTLV3_BUS_DCVS_LLCC_DDR_GOLD_LAT_EN_SPM_VOTE    = 0x43490000,
        MPCTLV3_BUS_DCVS_LLCC_DDR_PRIME_LAT_EN_SPM_VOTE   = 0x43494000,
        MPCTLV3_BUS_DCVS_LLCC_DDR_BOOST_FREQ              = 0x43498000,
        MPCTLV3_BUS_DCVS_LLCC_L3_BOOST_FREQ               = 0x4349C000,
        MPCTLV3_BUS_DCVS_LLCC_LLCC_BOOST_FREQ             = 0x434A0000,
        MPCTLV3_BUS_DCVS_LLCC_DDRQOS_BOOST_FREQ           = 0x434A4000,

        MPCTLV3_NPU_LLCC_BW_SAMPLE_MS                     = 0x43800000,
        MPCTLV3_NPU_LLCC_BW_IO_PERCENT                    = 0x43804000,
        MPCTLV3_NPU_LLCC_BW_HYST_OPT                      = 0x43808000,
        MPCTLV3_NPU_LLCC_DDR_BW_SAMPLE_MS                 = 0x4380C000,
        MPCTLV3_NPU_LLCC_DDR_BW_IO_PERCENT                = 0x43810000,
        MPCTLV3_NPU_LLCC_DDR_BW_HYST_OPT                  = 0x43814000,

        MPCTLV3_SCHED_ASYMCAP_BOOST                       = 0x43C00000,
        MPCTLV3_SCHED_TASK_LOAD_BOOST                     = 0x43C04000,
        MPCTLV3_SCHED_CLUSTER_UTIL_THRES_PCT              = 0X43C08000,
        MPCTLV3_SCHED_IDLE_ENOUGH                         = 0X43C0C000,
        MPCTLV3_SCHED_EM_INFLATE_PCT                      = 0X43C10000,
        MPCTLV3_SCHED_EM_INFLATE_THRES                    = 0X43C14000,
        MPCTLV3_SCHED_HEAVY_NR                            = 0X43C18000,
        MPCTLV3_SCHED_FMAX_CAP_BIG                        = 0X43C1C000,
        MPCTLV3_SCHED_FMAX_CAP_LITTLE                     = 0X43C1C100,
        MPCTLV3_SCHED_FMAX_CAP_PRIME                      = 0X43C1C200,
        MPCTLV3_SCHED_FMAX_CAP_TITANIUM                   = 0X43C1C300,
        MPCTLV3_SCHED_MAX_FREQ_PARTIAL_HALT               = 0X43C20000,
        MPCTLV3_SCHED_IDLE_ENOUGH_CLUST_BIG               = 0X43C24000,
        MPCTLV3_SCHED_IDLE_ENOUGH_CLUST_LITTLE            = 0X43C24100,
        MPCTLV3_SCHED_IDLE_ENOUGH_CLUST_PRIME             = 0X43C24200,
        MPCTLV3_SCHED_IDLE_ENOUGH_CLUST_TITANIUM          = 0X43C24300,
        MPCTLV3_SCHED_UTIL_THRES_PCT_CLUST_BIG            = 0X43C28000,
        MPCTLV3_SCHED_UTIL_THRES_PCT_CLUST_LITTLE         = 0X43C28100,
        MPCTLV3_SCHED_UTIL_THRES_PCT_CLUST_TITANIUM       = 0X43C28200,
        MPCTLV3_SCHED_UTIL_THRES_PCT_CLUST_PRIME          = 0X43C28300,
    };

    enum {
        VENDOR_TRIGGER = 2,
        VENDOR_SPEED_TRIGGER = 3,
        VENDOR_ULMK_TRIGGER = 4,
        VENDOR_TRIGGER_LIST_FAV_APPS = 5,
    };

    enum major_resource_opcode {
        DISPLAY_OFF_MAJOR_OPCODE = 0,  /* 0x0 */
        POWER_COLLAPSE_MAJOR_OPCODE,   /* 0x1 */
        CPUFREQ_MAJOR_OPCODE,          /* 0x2 */
        SCHED_MAJOR_OPCODE,            /* 0x3 */
        CORE_HOTPLUG_MAJOR_OPCODE,     /* 0x4 */
        INTERACTIVE_MAJOR_OPCODE,      /* 0x5 */
        CPUBW_HWMON_MAJOR_OPCODE,      /* 0x6 */
        VIDEO_MAJOR_OPCODE,            /* 0x7 */
        KSM_MAJOR_OPCODE,              /* 0x8 */
        ONDEMAND_MAJOR_OPCODE,         /* 0x9 */
        GPU_MAJOR_OPCODE,              /* 0xA */
        MISC_MAJOR_OPCODE,             /* 0xB */
        LLCBW_HWMON_MAJOR_OPCODE,      /* 0xC */
        MEMLAT_MAJOR_OPCODE,           /* 0xD */
        NPU_MAJOR_OPCODE,              /* 0xE */
        SCHED_EXT_MAJOR_OPCODE,        /* 0xF */
        MAX_MAJOR_RESOURCES
    };

    /* Enum for workload type and action to be taken for workload type. */
    enum workload_type {
        NOT_KNOWN = 0,
        APP = 1,
        GAME = 2,
        BROWSER = 3,
        PREPROAPP = 4
    };

    enum {
        LAUNCH_BOOST_V1 = 1,
        LAUNCH_BOOST_V2 = 2,
        LAUNCH_BOOST_V3 = 3,
        LAUNCH_BOOST_GAME = 4,
        LAUNCH_RESERVED_1 = 5,
        LAUNCH_RESERVED_2 = 6,
        LAUNCH_LL_DEFAULT = 7,
        LAUNCH_LAL = 8,
        LAUNCH_LGL = 9,
        LAUNCH_ACTIVITY = 10,
        LAUNCH_TYPE_SERVICE_START = 100,
        LAUNCH_TYPE_START_PROC = 101,
        LAUNCH_TYPE_APP_START_FROM_BG = 102,
        LAUNCH_TYPE_ATTACH_APPLICATION = 103,
        LAUNCH_BASE_BOOST_ATTACH_APP_LL = 104,
    };

    enum workload_db_action {
        DELETE = 0,
        INSERT = 1
    };

    enum {
        MPCTL_CMD_PERFLOCKACQ = 2,
        MPCTL_CMD_PERFLOCKREL = 3,
        MPCTL_CMD_PERFLOCKPOLL = 4,
        MPCTL_CMD_PERFLOCKRESET = 5,
        MPCTL_CMD_EXIT = 6,
        MPCTL_CMD_PERFLOCK_RESTORE_GOV_PARAMS = 7,
        MPCTL_CMD_PERFLOCKHINTACQ = 8,
        MPCTL_CMD_PERFGETFEEDBACK = 9,
        MPCTL_CMD_PERFEVENT = 10,
    };

    //do not change order of "resource minor groups"
    enum minor_resource_opcode {
        DISPLAY_START_INDEX = 0,
        DISPLAY_OFF_OPCODE = 0,
        MAX_DISPLAY_MINOR_OPCODE,

        POWER_COLLAPSE_START_INDEX = DISPLAY_START_INDEX + MAX_DISPLAY_MINOR_OPCODE,
        POWER_COLLAPSE_OPCODE = 0,     /*0x0*/
        L2_POWER_COLLAPSE_PERF_OPCODE, /*0x1*/
        LPM_BIAS_HYST_OPCODE,          /*0x2*/
        LPM_LEVELS_REF_STDDEV,
        LPM_LEVELS_TMR_ADD,
        LPM_IPI_PREDICTION,
        MAX_PC_MINOR_OPCODE,

        CPUFREQ_START_INDEX = POWER_COLLAPSE_START_INDEX + MAX_PC_MINOR_OPCODE,
        CPUFREQ_MIN_FREQ_OPCODE = 0, /* 0x0 */
        CPUFREQ_MAX_FREQ_OPCODE,     /* 0x1 */
        WALT_ADAPTIVE_LOW_FREQ_OPCODE,  /* 0x2 */
        WALT_ADAPTIVE_HIGH_FREQ_OPCODE, /* 0x3 */
        MAX_CPUFREQ_MINOR_OPCODE,

        SCHED_START_INDEX = CPUFREQ_START_INDEX + MAX_CPUFREQ_MINOR_OPCODE,
        SCHED_BOOST_OPCODE = 0,          /* 0x0 */
        SCHED_PREFER_IDLE_OPCODE,        /* 0x1 */
        SCHED_MIGRATE_COST_OPCODE,       /* 0x2 */
        SCHED_SMALL_TASK_OPCODE,         /* 0x3 */
        SCHED_MOSTLY_IDLE_LOAD_OPCODE,   /* 0x4 */
        SCHED_MOSTLY_IDLE_NR_RUN_OPCODE, /* 0x5 */
        SCHED_INIT_TASK_LOAD_OPCODE,     /* 0x6 */
        SCHED_UPMIGRATE_OPCODE,          /* 0x7 */
        SCHED_DOWNMIGRATE_OPCODE,        /* 0x8 */
        SCHED_MOSTLY_IDLE_FREQ_OPCODE,   /* 0x9 */
        SCHED_GROUP_OPCODE,              /* 0xA */
        SCHED_SPILL_NR_RUN_OPCODE,       /* 0xB */
        SCHED_STATIC_CPU_PWR_COST_OPCODE,/* 0xC */
        SCHED_RESTRICT_CLUSTER_SPILL_OPCODE,/* 0xD */
        SCHED_FREQ_AGGR_GROUP_OPCODE,       /* 0xE */
        SCHED_CPUSET_TOP_APP_OPCODE,     /* 0xF */
        SCHED_CPUSET_FOREGROUND_OPCODE,  /* 0x10 */
        SCHED_CPUSET_SYSTEM_BACKGROUND_OPCODE, /* 0x11 */
        SCHED_CPUSET_BACKGROUND_OPCODE,  /* 0x12 */
        SCHED_SET_FREQ_AGGR_OPCODE,      /* 0x13 */
        SCHED_ENABLE_THREAD_GROUPING_OPCODE,   /* 0x14 */
        SCHED_GROUP_UPMIGRATE_OPCODE,   /* 0x15 */
        SCHED_GROUP_DOWNMIGRATE_OPCODE,   /* 0x16 */
        SCHED_FREQ_AGGR_THRESHOLD_OPCODE,   /* 0x17 */
        SCHEDTUNE_PREFER_IDLE_OPCODE,      /*0x18*/
        SCHED_INITIAL_TASK_UTIL_OPCODE,      /*0x19*/
        SCHED_LOAD_BOOST_OPCODE,            /*0x1A*/
        SCHED_SCHED_LITTLE_CLUSTER_COLOC_FMIN_KHZ, /*0x1B*/
        SCHEDTUNE_BOOST_OPCODE,          /* 0x1C */
        SCHED_BUSY_HYSTERSIS_CPU_MASK_OPCODE,   /* 0x1D */
        SCHED_MIN_TASK_UTIL_FOR_COLOCATION,        /*0x1E*/
        SCHED_MIN_TASK_UTIL_FOR_BOOST,             /*0x1F*/
        SCHED_TASK_BOOST, /*0x20*/
        SCHED_USER_HINT, /*0x21*/
        SCHED_TASK_UNFILTER_NR_WINDOWS, /*0x22*/
        SCHED_COLOC_DOWNMIGRATE_NS, /*0x23*/
        SCHED_BUSY_HYSTERESIS_ENABLE_COLOC_CPUS, /*0x24*/
        SCHED_COLOC_BIAS_HYST, /*0x25*/
        SCHED_WINDOW_STATS_POLICY, /*0x26*/
        SCHED_MANY_WAKEUP_THRESHOLD, /*0x27*/
        SCHED_SYNC_HINT_ENABLE,/*0x28*/
        SCHED_WINDOW_TICKS_UPDATE, /*0x29*/
        SCHED_PREFER_SPREAD, /*0x2A*/
        SCHED_UCLAMP_BOOST, /*0x2B*/
        SCHED_ENABLE_TASK_BOOST_RENDERTHREAD, /*0x2C*/
        SCHED_DISABLE_TASK_BOOST_RENDERTHREAD, /*0x2D*/
        SCHED_TASK_UNFILTER_PERIOD, /*0x2E*/
        SCHED_CONSERVATIVE_PL, /*0x2F*/
        SCHED_COLOC_BUZY_HYST_CPU_PCT, /*0x30*/
        SCHED_COLOC_BUZY_HYST_CPU_NS, /*0x31*/
        WALT_RTG_CFS_BOOST_PRIO, /*0x32*/
        SCHED_FORCE_LB_ENABLE, /*0x33*/
        SCHED_LOW_LATENCY, /*0x34*/
        SCHED_MIN_GRANULARITY_NS, /*0x35*/
        WALT_LOW_LATENCY_TASK_THRESHOLD, /*0x36*/
        SCHED_TUNE_PREFER_IDLE_FOREGROUND, /*0x37*/
        SCHED_UP_DOWN_MIGRATE, /*0x38*/
        STUNE_TOPAPP_SCHEDTUNE_COLOCATE, /*0x39*/
        CPUCTL_TOPAPP_UCLAMP_LATENCY_SENSITIVE, /*0x3A*/
        CPUCTL_FG_UCLAMP_LATENCY_SENSITIVE, /*0x3B*/
        SCHED_WAKE_UP_IDLE, /*0x3C*/
        SCHED_GROUP_UP_DOWN_MIGRATE, /*0x3D*/
        SCHED_UTIL_BUSY_HYST_CPU_NS, /*0x3E*/
        SCHED_MIN_TASK_UTIL_FOR_UCLAMP, /*0x3F*/
        MAX_SCHED_MINOR_OPCODE,

        CORE_HOTPLUG_START_INDEX = SCHED_START_INDEX + MAX_SCHED_MINOR_OPCODE,
        CORE_HOTPLUG_MIN_CORE_ONLINE_OPCODE = 0,
        CORE_HOTPLUG_MAX_CORE_ONLINE_OPCODE,
        CORE_CTL_ENABLE_BIG_OPCODE,
        CORE_CTL_CPU_NOT_PREFERRED_BIG,
        CORE_CTL_OFFLINE_DELAY_MS_BIG,
        CORE_CTL_MIN_PARTIAL_CPUS_BIG,
        MAX_CORE_HOTPLUG_MINOR_OPCODE,

        INTERACTIVE_START_INDEX = CORE_HOTPLUG_START_INDEX + MAX_CORE_HOTPLUG_MINOR_OPCODE,
        INTERACTIVE_ABOVE_HISPEED_DELAY_OPCODE = 0,  /* 0x0 */
        INTERACTIVE_BOOST_OPCODE,                    /* 0x1 */
        INTERACTIVE_BOOSTPULSE_OPCODE,               /* 0x2 */
        INTERACTIVE_BOOSTPULSE_DURATION_OPCODE,      /* 0x3 */
        INTERACTIVE_GO_HISPEED_LOAD_OPCODE,          /* 0x4 */
        INTERACTIVE_HISPEED_FREQ_OPCODE,             /* 0x5 */
        INTERACTIVE_IO_IS_BUSY_OPCODE,               /* 0x6 */
        INTERACTIVE_MIN_SAMPLE_TIME_OPCODE,          /* 0x7 */
        INTERACTIVE_TARGET_LOADS_OPCODE,             /* 0x8 */
        INTERACTIVE_TIMER_RATE_OPCODE,               /* 0x9 */
        INTERACTIVE_TIMER_SLACK_OPCODE,              /* 0xA */
        INTERACTIVE_MAX_FREQ_HYSTERESIS_OPCODE,      /* 0xB */
        INTERACTIVE_USE_SCHED_LOAD_OPCODE,           /* 0xC */
        INTERACTIVE_USE_MIGRATION_NOTIF_OPCODE,      /* 0xD */
        INTERACTIVE_IGNORE_HISPEED_NOTIF_OPCODE,     /* 0xE */
        SCHEDUTIL_HISPEED_FREQ_OPCODE,               /* 0xF */
        SCHEDUTIL_HISPEED_LOAD_OPCODE,               /* 0x10 */
        SCHEDUTIL_PREDICTIVE_LOAD_OPCODE,            /* 0x11 */
        SCHEDUTIL_DOWN_RATE_LIMIT_OPCODE,            /* 0x12 */
        SCHEDUTIL_RTG_BOOST_FREQ_OPCODE,             /* 0x13 */
        SCHEDUTIL_TARGET_LOAD_THRESH_OPCODE,         /* 0X14 */
        SCHEDUTIL_TARGET_LOAD_SHIFT_OPCODE,          /* 0X15 */
        SCHEDUTIL_UP_RATE_LIMIT_US_OPCODE,           /* 0x16 */
        MAX_INTERACTIVE_MINOR_OPCODE,

        CPUBW_HWMON_START_INDEX = INTERACTIVE_START_INDEX + MAX_INTERACTIVE_MINOR_OPCODE,
        CPUBW_HWMON_MINFREQ_OPCODE = 0,
        CPUBW_HWMON_DECAY_RATE_OPCODE,
        CPUBW_HWMON_IO_PERCENT_OPCODE,
        CPUBW_HWMON_HYST_OPT_OPCODE,
        CPUBW_HWMON_LOW_POWER_CEIL_MBPS,
        CPUBW_HWMON_LOW_POWER_IO_PERCENT,
        CPUBW_HWMON_MAXFREQ_OPCODE,
        CPUBW_HWMON_POLLING_INTERVAL_OPCODE,
        CPUBW_HWMON_SAMPLE_MS,
        CPUBW_HWMON_IDLE_MBPS,
        CPU_LLCC_BW_MIN_FREQ,
        CPU_LLCC_BW_UP_SCALE,
        CPU_LLCC_BW_USE_AB,
        CPU_LLCC_BW_IO_PERCENT,
        CPU_LLCC_BW_HYST_OPT,
        CPU_LLCC_BW_SAMPLE_MS,
        CPU_LLCC_BW_POLLING_INTERVAL,
        CPU_LLCC_BW_MINFREQ_OPCODE_V2,
        CPU_LLCC_BW_MAXFREQ_OPCODE_V2,
        MAX_CPUBW_HWMON_MINOR_OPCODE,

        VIDEO_START_INDEX = CPUBW_HWMON_START_INDEX + MAX_CPUBW_HWMON_MINOR_OPCODE,
        VIDEO_ENCODE_PB_HINT = 0,
        VIDEO_DECODE_PB_HINT,
        VIDEO_DISPLAY_PB_HINT,
        DISPLAY_EARLY_WAKEUP_HINT,
        MAX_VIDEO_MINOR_OPCODE,

        KSM_START_INDEX = VIDEO_START_INDEX + MAX_VIDEO_MINOR_OPCODE,
        KSM_ENABLE_DISABLE_OPCODE = 0,
        KSM_SET_RESET_OPCODE,
        MAX_KSM_MINOR_OPCODE,

        ONDEMAND_START_INDEX = KSM_START_INDEX + MAX_KSM_MINOR_OPCODE,
        OND_SAMPLING_RATE_OPCODE = 0,
        OND_IO_IS_BUSY_OPCODE,
        OND_SAMPLING_DOWN_FACTOR_OPCODE,
        OND_SYNC_FREQ_OPCODE,
        OND_OPIMAL_FREQ_OPCODE,
        OND_ENABLE_STEP_UP,
        OND_MAX_INTERMEDIATE_STEPS,
        NOTIFY_ON_MIGRATE,
        MAX_OND_MINOR_OPCODE,

        GPU_START_INDEX = ONDEMAND_START_INDEX + MAX_OND_MINOR_OPCODE,
        GPU_POWER_LEVEL = 0,
        GPU_MIN_POWER_LEVEL,
        GPU_MAX_POWER_LEVEL,
        GPU_MIN_FREQ_OPCODE,
        GPU_MAX_FREQ_OPCODE,
        GPU_BUS_MIN_FREQ_OPCODE,
        GPU_BUS_MAX_FREQ_OPCODE,
        GPU_DISABLE_GPU_NAP_OPCODE,
        GPU_IS_APP_FG_OPCODE,
        GPU_IS_APP_BG_OPCODE,
        GPU_LOAD_MOD_PERCENT_OPCODE,
        GPU_IDLE_TIMER_OPCODE,
        GPU_MIN_FREQ_MHZ_OPCODE,
        MAX_GPU_MINOR_OPCODE,

        MISC_START_INDEX = GPU_START_INDEX + MAX_GPU_MINOR_OPCODE,
        UNSUPPORTED_OPCODE = 0,
        IRQ_BAL_OPCODE,
        INPUT_BOOST_RESET_OPCODE,
        SWAP_RATIO_OPCODE,
        STORAGE_CLK_SCALING_DISABLE_OPCODE,
        NET_KEEP_ALIVE_OPCODE,
        DISABLE_PPR,
        DISABLE_PASR,
        PID_AFFINE,
        FPS_HYST_OPCODE,
        ALWAYS_ALLOW_OPCODE,
        SET_SCHEDULER,
        SCHED_THREAD_PIPELINE,
        DISPLAY_DOZE_OPCODE,
        DISPLAY_HEAVY_RT_AFFINE,
        CONTENT_FPS_OPCODE,
        GOLD_DYNPREFETCHER_OPCODE,
        MAX_MISC_MINOR_OPCODE,

        LLCBW_HWMON_START_INDEX = MISC_START_INDEX + MAX_MISC_MINOR_OPCODE,
        LLCBW_HWMON_MINFREQ_OPCODE = 0,
        LLCBW_HWMON_IO_PERCENT_OPCODE,
        LLCBW_HWMON_HYST_OPT_OPCODE,
        LLCBW_HWMON_SAMPLE_MS,
        LLCC_DDR_BW_MIN_FREQ,
        LLCC_DDR_BW_UP_SCALE,
        LLCC_DDR_BW_MAX_FREQ,
        LLCC_DDR_BW_DECAY_RATE,
        LLCC_DDR_BW_IO_PERCENT,
        LLCC_DDR_BW_HYST_OPT,
        LLCC_DDR_BW_LOW_POWER_CEIL_MBPS,
        LLCC_DDR_BW_LOW_POWER_IO_PERCENT,
        LLCC_DDR_BW_POLLING_INTERVAL,
        LLCC_DDR_BW_SAMPLE_MS,
        LLCC_DDR_BW_IDLE_MBPS,
        LLCC_DDR_BW_MINFREQ_OPCODE_V2,
        LLCC_DDR_BW_MAXFREQ_OPCODE_V2,
        LLCC_DDR_BW_USE_AB,
        LLCC_DDR_BW_AB_SCALE,
        MAX_LLCBW_HWMON_MINOR_OPCODE,

        MEMLAT_START_INDEX = LLCBW_HWMON_START_INDEX + MAX_LLCBW_HWMON_MINOR_OPCODE,
        L3_MEMLAT_MINFREQ_OPCODE = 0,
        L2_MEMLAT_RATIO_CEIL_0_OPCODE,
        L2_MEMLAT_RATIO_CEIL_1_OPCODE,
        L3_MEMLAT_STALL_FLOOR_0_OPCODE,
        L3_MEMLAT_STALL_FLOOR_1_OPCODE,
        MEMLAT_MIN_FREQ_0_OPCODE,
        MEMLAT_MIN_FREQ_1_OPCODE,
        LLCC_MEMLAT_MIN_FREQ_OPCODE,
        LLCC_MEMLAT_RATIO_CELL_0_OPCODE,
        LLCC_MEMLAT_RATIO_CELL_1_OPCODE,
        LLCC_MEMLAT_STALL_FLOOR_0_OPCODE,
        LLCC_MEMLAT_STALL_FLOOR_1_OPCODE,
        LLCC_DDR_LAT_MIN_FREQ_OPCODE,
        LLCC_DDR_LAT_RATIO_CELL_0_OPCODE,
        LLCC_DDR_LAT_RATIO_CELL_1_OPCODE,
        LLCC_DDR_LAT_STALL_FLOOR_0_OPCODE,
        LLCC_DDR_LAT_STALL_FLOOR_1_OPCODE,
        L3_MEMLAT_MAXFREQ_OPCODE,
        CPU_CPU_DDR_LATFLOOR_MINFREQ_OPCODE,
        CPU_CPU_DDR_LATFLOOR_MAXFREQ_OPCODE,
        LLCC_MEMLAT_MAX_FREQ_OPCODE,
        LLCC_DDR_LAT_MAX_FREQ_OPCODE,
        BUS_DCVS_L3_MEMLAT_MINFREQ_PRIME_OPCODE,
        BUS_DCVS_LLCC_MEMLAT_MINFREQ_SILVER_OPCODE,
        BUS_DCVS_LLCC_DDR_LAT_MINFREQ_OPCODE,
        BUS_DCVS_LLCC_DDR_LAT_FREQ_SCALE_PCT_OPCODE,
        BUS_DCVS_MEMLAT_SAMPLE_MS_OPCODE,
        BUS_DCVS_DDR_GOLD_COMPUTE_MAX_FREQ_OPCODE,
        BUS_DCVS_LLCC_GOLD_COMPUTE_MAX_FREQ_OPCODE,
        BUS_DCVS_DDR_PRIME_LATFLOOR_IPM_CEIL_OPCODE,
        BUS_DCVS_DDR_MEMLAT_ADAPTIVE_HIGH_FREQ_OPCODE,
        BUS_DCVS_DDR_MEMLAT_ADAPTIVE_LOW_FREQ_OPCODE,
        BUS_DCVS_L3_MEMLAT_MINFREQ_GOLD_OPCODE,
        BUS_DCVS_LLCC_DDR_LAT_MINFREQ_PRIME_OPCODE,
        BUS_DCVS_LLCC_DDR_LAT_MINFREQ_GOLD_OPCODE,
        BUS_DCVS_LLCC_MEMLAT_MINFREQ_GOLD_OPCODE,
        BUS_DCVS_LLCC_DDR_GOLD_LAT_EN_SPM_VOTE,
        BUS_DCVS_LLCC_DDR_PRIME_LAT_EN_SPM_VOTE,
        BUS_DCVS_LLCC_DDR_BOOST_FREQ,
        BUS_DCVS_LLCC_L3_BOOST_FREQ,
        BUS_DCVS_LLCC_LLCC_BOOST_FREQ,
        BUS_DCVS_LLCC_DDRQOS_BOOST_FREQ,
        MAX_MEMLAT_MINOR_OPCODE,

        NPU_START_INDEX = MEMLAT_START_INDEX + MAX_MEMLAT_MINOR_OPCODE,
        NPU_LLCBW_HWMON_SAMPLE_MS = 0,
        NPU_LLCBW_HWMON_IO_PERCENT,
        NPU_LLCBW_HWMON_HYST_OPT_OPCODE,
        NPU_LLC_DDR_HWMON_SAMPLE_MS,
        NPU_LLC_DDR_HWMON_IO_PERCENT,
        NPU_LLC_DDR_HWMON_HYST_OPT_OPCODE,
        MAX_NPU_MINOR_OPCODE,

        SCHED_EXT_START_INDEX = NPU_START_INDEX + MAX_NPU_MINOR_OPCODE,
        SCHED_ASYMCAP_BOOST = 0,
        SCHED_TASK_LOAD_BOOST, /*0x1*/
        SCHED_CLUSTER_UTIL_THRES_PCT, /*0x2*/
        SCHED_IDLE_ENOUGH, /*0x3*/
        SCHED_EM_INFLATE_PCT, /*0x4*/
        SCHED_EM_INFLATE_THRES, /*0x5*/
        SCHED_HEAVY_NR, /*0x6*/
        SCHED_FMAX_CAP, /*0x7*/
        SCHED_MAX_FREQ_PARTIAL_HALT, /*0x8*/
        SCHED_IDLE_ENOUGH_CLUST, /*0x9*/
        SCHED_UTIL_THRES_PCT_CLUST, /*0xA*/
        MAX_SCHED_EXT_MINOR_OPCODE,

        MAX_MINOR_RESOURCES = MAX_DISPLAY_MINOR_OPCODE + MAX_PC_MINOR_OPCODE +
                            MAX_CPUFREQ_MINOR_OPCODE + MAX_SCHED_MINOR_OPCODE +
                            MAX_CORE_HOTPLUG_MINOR_OPCODE + MAX_INTERACTIVE_MINOR_OPCODE +
                            MAX_CPUBW_HWMON_MINOR_OPCODE + MAX_VIDEO_MINOR_OPCODE +
                            MAX_KSM_MINOR_OPCODE + MAX_OND_MINOR_OPCODE + MAX_GPU_MINOR_OPCODE +
                            MAX_MISC_MINOR_OPCODE + MAX_LLCBW_HWMON_MINOR_OPCODE +
                            MAX_MEMLAT_MINOR_OPCODE + MAX_NPU_MINOR_OPCODE +
                            MAX_SCHED_EXT_MINOR_OPCODE
    };

    enum sysnodes {
        SYSNODE_START = -1,
        KPM_NUM_CLUSTERS = 0,
        KPM_MANAGED_CPUS,
        KPM_CPU_MAX_FREQ_NODE,
        POLLPATH,
        KPM_MAX_CPUS,
        CPU_INSTRUCTIONS_NODE,
        SCROLL_NOTIF,
        GFX_EVT_NODE,
        GFX_PID_NODE,
        PROC_MEMINFO,
        COMPACTION_PROACTIVENESS,
        AGGR_BIG_NR,
        AGGR_TOP_LOAD,
        CORE_CTL_REGISTER,
        TOP_LOAD_CLUSTER,
        CURR_CAP_CLUSTER,
        GPU_AVAILABLE_FREQUENCIES,
        GPU_CLOCK_STATS,
        GPUCLK,
        GPU_BUSY_PERCENTAGE,
        MEASURED_FPS,
        FPS_PERIODICITY_MS,
        RETIRE_FRAME_EVENT,
        LAUNCH_PLH_NOTIF,
        HW_GPLAF_NOTIFY,
        HW_GPLAF_DATA_NODE,
        GPLAF_HEALTH_NODE,
        DRAG_NOTIF,
        SYSNODE_END,
    };

    #define MSG_VERSION 1

    #define MAX_RESOURCES_PER_REQUEST 32
    #define MAX_ARGS_PER_REQUEST (MAX_RESOURCES_PER_REQUEST*2)
    #define PROP_VAL_LENGTH     PROPERTY_VALUE_MAX

    /*newer resources
    supported from v3.0 onwards*/
    #define MAX_RESERVE_ARGS_PER_REQUEST 32
    #define MAX_MSG_APP_NAME_LEN 128

    typedef struct mpctl_msg_t {
        uint16_t data;
        int32_t pl_handle;
        uint8_t req_type;
        int32_t pl_time;
        int32_t pl_args[MAX_ARGS_PER_REQUEST];
        int32_t reservedArgs[MAX_RESERVE_ARGS_PER_REQUEST];
        int32_t numRArgs;
        pid_t client_pid;
        pid_t client_tid;
        uint32_t hint_id;
        int32_t hint_type;
        void *userdata;
        char usrdata_str[MAX_MSG_APP_NAME_LEN];
        char propDefVal[PROP_VAL_LENGTH];
        bool renewFlag;
        bool offloadFlag;
        int32_t app_workload_type;
        int32_t app_pid;
        int16_t version;
        int16_t size;
    } mpctl_msg_t;

    int32_t perfmodule_init(void);
    void perfmodule_exit(void);
    int perfmodule_submit_request(mpctl_msg_t *msg);

    /*obsolete*/
    const char* perfmodule_sync_request(int32_t cmd);

    void perfmodule_sync_request_ext(int32_t cmd, char **debugInfo);

#ifdef __cplusplus
}
#endif

class VendorIPerf {

protected:
    uint16_t mMaxArgsPerReq;
    string mTargetName;
    static VendorIPerf mCurrVendor;
    VendorIPerf(VendorIPerf const& oh);
    VendorIPerf& operator=(VendorIPerf const& oh);
    VendorIPerf();

public:

    virtual ~VendorIPerf();
    static VendorIPerf &getVendorIPerf();
    string &getVendorTargetName() {
        return mTargetName;
    }

    uint16_t getMaxArgsPerReq() {
        return mMaxArgsPerReq;
    }

    virtual int32_t GetSysNode(const int32_t idx_value, char *node_path);
    virtual float GetVendorFpsFile();
};

#endif /*__PERF_VENDORINTERFACE_H__*/
